import javax.swing.JPanel;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import java.io.*;

//------------------------------------------------------------------------
// Class
//------------------------------------------------------------------------
public class Store extends JFrame
				   implements ActionListener {

	JTextField key;
	JTextArea area;
	JButton decode;
	JButton save;
	Message message= new Message();

//------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------
	public Store() {
		init();
		loadData();
	}

//------------------------------------------------------------------------
// Methods
//------------------------------------------------------------------------
	private void init() {
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setSize(800, 500);
		this.setTitle("Store your information encrypted");

		this.getContentPane().setLayout(new BorderLayout());

		JPanel p= new JPanel(new BorderLayout());
		JLabel l= new JLabel("Key:   ");
		key= new JTextField();
		p.add(l, BorderLayout.WEST);
		p.add(key, BorderLayout.CENTER);
		this.getContentPane().add(p, BorderLayout.NORTH);

		area= new JTextArea();
		JScrollPane sp= new JScrollPane(area);
		this.getContentPane().add(sp, BorderLayout.CENTER);

		p= new JPanel(new GridLayout(1, 2));
		decode= new JButton("Decode");
		decode.addActionListener(this);
		save= new JButton("Save");
		save.addActionListener(this);
   		save.setEnabled(false);
		p.add(decode);
		p.add(save);
		this.getContentPane().add(p, BorderLayout.SOUTH);


		this.setVisible(true);
	}

//------------------------------------------------------------------------
	public static void main(String[] args) {
		System.out.println("Store starting up...");
		Store store= new Store();

	}

//------------------------------------------------------------------------
	private byte[] code() {
		byte[] skey= key.getText().getBytes();
		try {
			SecretKeySpec skeySpec= new SecretKeySpec(skey, "Blowfish");
			Cipher cipher= Cipher.getInstance("Blowfish");
			cipher.init(Cipher.ENCRYPT_MODE, skeySpec);
			byte[] encrypted= cipher.doFinal(area.getText().getBytes());
			return encrypted;
		}
		catch(Exception e) {
			Object[] options = {"OK"};
			int d= JOptionPane.showOptionDialog(this,
				"Error in encoding the information:\n"+e,
				"Error encoding",
    			JOptionPane.DEFAULT_OPTION,
    			JOptionPane.ERROR_MESSAGE,
    			null,     //don't use a custom Icon
    			options,  //the titles of buttons
    			options[0]); //default button title
		}
		return null;
	}
//------------------------------------------------------------------------
	private void decode() {
		byte[] raw= message.getMessage();
		byte[] skey= key.getText().getBytes();
		String txt= null;
		try {
			SecretKeySpec skeySpec= new SecretKeySpec(skey, "Blowfish");
			Cipher cipher= Cipher.getInstance("Blowfish");
			cipher.init(Cipher.DECRYPT_MODE, skeySpec);
			byte[] decrypted= cipher.doFinal(raw);
			txt= new String(decrypted);
    		save.setEnabled(true);
		}
		catch(Exception e) {
			Object[] options = {"OK"};
			int d= JOptionPane.showOptionDialog(this,
				"Error in decoding the information:\n"+e,
				"Error decoding",
    			JOptionPane.DEFAULT_OPTION,
    			JOptionPane.ERROR_MESSAGE,
    			null,     //don't use a custom Icon
    			options,  //the titles of buttons
    			options[0]); //default button title
    		save.setEnabled(false);
		}
		area.setText(txt);
	}

//------------------------------------------------------------------------
	private void saveData() {
		try {
			byte[] codedMessage= code();
			if(codedMessage!=null) {
				message.setMessage(codedMessage);
				String filename= "store.dat";
				FileOutputStream out= new FileOutputStream(filename);
				ObjectOutputStream s= new ObjectOutputStream(out);
				s.writeObject(message);
				out.close();
				s.close();
				System.out.println("Store saved");
			}
			else {
				System.out.println("Problem encoding message.");
			}
		}
		catch(Exception e) {
			System.out.println("Problem saving store: "+e);
		}
	}
//------------------------------------------------------------------------
	private void loadData() {
		try {
			String filename= "store.dat";
			FileInputStream in= new FileInputStream(filename);
			ObjectInputStream s= new ObjectInputStream(in);
			message= (Message)s.readObject();
			in.close();
			s.close();
			System.out.println("Store loaded");
		}
		catch(Exception e) {
			System.out.println("Problem loading store: "+e);
    		// This can happen if no store was defined yet.
    		if(e.getClass().isInstance(new FileNotFoundException()))
    			save.setEnabled(true);
		}
	}

//------------------------------------------------------------------------
// ActionPerformed method
//------------------------------------------------------------------------
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==decode) {
			System.out.println("Decode");
			decode();
		}
		if(e.getSource()==save) {
			System.out.println("Save");
			saveData();
		}
	}
}
